﻿using Microsoft.EntityFrameworkCore;
using Microsoft.Extensions.Configuration;
using System;

namespace TestProject
{
    /// <summary>
    /// 커스텀 구성 소스
    /// </summary>
    public class CustomConfigurationSource : IConfigurationSource
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 옵션 액션
        /// </summary>
        private readonly Action<DbContextOptionsBuilder> optionsAction;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - CustomConfigurationSource(optionsAction)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="optionsAction">옵션 액션</param>
        public CustomConfigurationSource(Action<DbContextOptionsBuilder> optionsAction)
        {
            this.optionsAction = optionsAction;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 빌드하기 - Build(builder)

        /// <summary>
        /// 빌드하기
        /// </summary>
        /// <param name="builder">빌더</param>
        /// <returns>구성 공급자</returns>
        public IConfigurationProvider Build(IConfigurationBuilder builder)
        {
            return new CustomConfigurationProvider(this.optionsAction);
        }

        #endregion
    }
}