﻿using Microsoft.EntityFrameworkCore;
using Microsoft.Extensions.Configuration;
using System;

namespace TestProject
{
    /// <summary>
    /// 커스텀  확장
    /// </summary>
    public static class CustomExtension
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region EF 구성 추가하기 - AddEFConfiguration(builder, optionsAction)

        /// <summary>
        /// EF 구성 추가하기
        /// </summary>
        /// <param name="builder">빌더</param>
        /// <param name="optionsAction">옵션 액션</param>
        /// <returns>구성 빌더</returns>
        public static IConfigurationBuilder AddEFConfiguration
        (
            this IConfigurationBuilder      builder,
            Action<DbContextOptionsBuilder> optionsAction
        )
        {
            return builder.Add(new CustomConfigurationSource(optionsAction));
        }

        #endregion
    }
}